namespace AdrianKousz.Util.Logging
{
	public class LogMsg
	{
		public readonly int Level;
		public readonly string Tag;
		public readonly string Message;
		public readonly System.DateTime Timestamp;

		public LogMsg(int level, string tag, string message)
		{
			this.Level = level;
			this.Tag = tag;
			this.Message = message;
			this.Timestamp = System.DateTime.Now;
		}
	}
}
