﻿/*

// Enable if .NET < 3.5
// Links:
// * http://geekswithblogs.net/robp/archive/2007/12/20/using-extension-methods-in-.net-2.0-with-visual-studio-2008.aspx
// * http://www.danielmoth.com/Blog/Using-Extension-Methods-In-Fx-20-Projects.aspx

namespace System.Runtime.CompilerServices
{
	[AttributeUsage(AttributeTargets.Method)]
	public class ExtensionAttribute : Attribute { }
}

namespace System
{
	public delegate void Action();
	// public delegate void Action<in T>(T obj); // Already present
	public delegate void Action<in T1, in T2>(T1 arg1, T2 arg2);
	public delegate void Action<in T1, in T2, in T3>(T1 arg1, T2 arg2, T3 arg3);

	public delegate TResult Func<out TResult>();
	public delegate TResult Func<in T, out TResult>(T arg);
	public delegate TResult Func<in T1, in T2, out TResult>(T1 arg1, T2 arg2);
	public delegate TResult Func<in T1, in T2, in T3, out TResult>(T1 arg1, T2 arg2, T3 arg3);
}

//*/
